#include <stdio.h>
#include <dlfcn.h>
#include <sys/time.h>
#include <time.h>

const char *ourgv[24] ={ "check_hello", NULL };
const char *ourcmd = "check_hello";
extern int optind;

int main(){
	int i;
	struct timeval start, midway, end;
	long total_func, total_sys;
	void *libhandle=NULL; 
	int (*check_func)(int, const char**)=NULL;
	libhandle=dlopen("./check_hello.so", RTLD_NOW);
	if(libhandle==NULL){
		fprintf(stderr, "libhandle was null.  damn. %s\n", dlerror());
	}
	*(void**)(&check_func) =dlsym(libhandle, "check_hello");
	if(check_func==NULL || *check_func == NULL){
		fprintf(stderr, "check_func was null.  damn. %s\n", dlerror());
	}
	
	gettimeofday(&start, NULL);
	for(i=0; i<1000; i++){
		system(ourcmd);
	}
	gettimeofday(&midway, NULL);
	for(i=0; i<1000; i++){
		(*check_func)(1, ourgv);
	}
	gettimeofday(&end, NULL);

	total_sys = ((midway.tv_sec - start.tv_sec)*1000000) + (midway.tv_usec - start.tv_usec);
	total_func = ((end.tv_sec - midway.tv_sec)*1000000) + (end.tv_usec - midway.tv_usec);

	fprintf(stderr, "dlopen: %ld\n", total_func);
	fprintf(stderr, "system: %ld\n", total_sys);
}
